/////////////////////////////////////////////////////////////////////////////////
//
// EventListener.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: EventListener.h,v $
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */

#pragma once


#include <pgpConfig.h>
#define PGP_WIN32 1
#include <pgpMemoryMgr.h>
#include <pgpPubTypes.h>
#include <pgpSDKPrefs.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <pgpUtilities.h>
#include <pgpErrors.h>
#include <pgpUserInterface.h>


/////////////////////////////////////////////////////////////////////////////////
//
class CEventListener
{
public:
    virtual ~CEventListener() {}
    virtual PGPError ListenEvent(PGPContextRef context, PGPEvent* event) = 0;
};


/////////////////////////////////////////////////////////////////////////////////
//
PGPOptionListRef PGPOSetEventHandler(PGPContextRef context, CEventListener* pEventListener);
static PGPError PGPEventHandler(PGPContextRef context, PGPEvent* event, PGPUserValue userValue);


/////////////////////////////////////////////////////////////////////////////////
//
