/////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2.h
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2.h,v $
 * Revision 1.1  2000/08/06 15:14:41  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 */


#pragma once

#include <windows.h>
#include <pgpConfig.h>
#define PGP_WIN32 1
#include <pgpMemoryMgr.h>
#include <pgpPubTypes.h>
#include <pgpSDKPrefs.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <pgpUtilities.h>
#include <pgpErrors.h>
#include <pgpUserInterface.h>
#include <stdio.h>
#include <stdlib.h>
#include <mbstring.h>
#include <time.h>

#include "BkMessage.h"
#include "SignatureListener.h"
#include "DecryptListener.h"
#include "main.h"

/////////////////////////////////////////////////////////////////////////////////
//
class CPgpb2
{
public:
    CPgpb2();
    virtual ~CPgpb2();
    BOOL PGPOutgoing1(HWND hWnd, PGPContextRef context);
    BOOL PGPOutgoing2(HWND hWnd, PGPContextRef context);
    BOOL PGPOutgoing3(HWND hWnd, PGPContextRef context);
    BOOL PGPIncoming1(HWND hWnd, PGPContextRef context);

protected:
private:
    BOOL DecodePgpMailPart(CBkMessage& mail, HWND hWnd, PGPContextRef context);
    BOOL DecodePgpMailPart2(CBkMessage& mail, HWND hWnd, PGPContextRef context);
    BOOL PGPVerifyDetachedSignature(count_ptr<CBkMailPart> mail, HWND hWnd, PGPContextRef context);
    BOOL PGPDecrypt(count_ptr<CBkMailPart> mail, HWND hWnd, PGPContextRef context);
    BOOL ExplainSigningMessage(CBkMessage& mail, CSignatureListener& sigListener);

    int AddAddressList(CPointerList& plstAddr, LPCTSTR lpszToCcBcc);
    BOOL GetKeySet(CPointerItem* pItem, PGPContextRef context, PGPKeySetRef& foundUserKeys);
    BOOL GetHashAlgorithm(PGPKeyRef& signingKey, LPSTR lpHash);
    void CutBufferEndCRLF(LPSTR lpBody);

    CB2API* m_pbka;
    BOOL m_bPGPMIME;
};